#include "getvalue.h"
#include <unistd.h>

// This file was written by Emanuelle Goulet

#define LONGMAX 20
#define LMAX 100	//longueur max des chaines affichees sur une ligne
                        //dans le tableau d'aide (pour un shortname de 8)
// ------------------------------------ affichage des commandes possibles
void display_help(int nb, AskStruct *questions) {
	int i,j,k;

	for (i=0; i < nb; i++){                      //tableau
		if (!strlen(questions[i].shortname))
			cerr << questions[i].longname << endl;
		else
		if (questions[i].vartype!=LISTVAL){
			cerr.width(8);
			cerr << questions[i].shortname ;
			switch (questions[i].vartype){
				case INTVAL:   cerr << "=[int]    ";break;
				case REALVAL:  cerr << "=[real]   ";break;
				case BOOLVAL:  cerr << "          ";break;
				case STRINGVAL:cerr << "=[string] ";break;
				case CHOICEVAL:cerr << "=[choice] ";break;
			default: break;
			}
			//decoupage des phrases trop longues
			if(strlen(questions[i].longname) > LMAX){	 //premier morceau
			  for (j=0; j<LMAX+1; j++) {
					cerr << questions[i].longname[j];
			  }
				cerr << endl;
				//autres lignes de texte
				if (strlen(questions[i].longname) > LMAX+1)
					for (k=0; k<((strlen(questions[i].longname))/LMAX);k++){
						cerr << "                  ";	//20 blancs
						for (j=j; j< strlen(questions[i].longname) && j< (LMAX+1)*(k+2); j++) {
							cerr << questions[i].longname[j];
						}
						cerr << endl;
					}
			}
			else {
				//ajuster les espaces si on allonge les vartypes
				cerr << "" << questions[i].longname;
				cerr << endl;
			}
		}
	}
}

// ----------------------------------- 	Lecture de la ligne de commande
//                                      Version struct dans AskStruct

int get_values(int argc, char* argv[], int nb, AskStruct *questions) {

	char nomCherche[LONGMAX];
	int noFich=0;
	int i, j, k, n, valide, trouve=0, existe, tmpint,operFich=0;;
	float tmpfl;

								//initialise les BOOLVAL
	for (k=0, existe=0; k<nb; k++ ) {
		if (questions[k].vartype==BOOLVAL)
			*((int *)questions[k].outvar)=0;
		if (questions[k].vartype==LISTVAL)
			((ListFich *)questions[k].outvar)->nbre=0;
	}
	for (i=1; i < argc; i++){
	valide=0;
								//initialise nomCherche
			for (n=0; n<LONGMAX; n++){
				nomCherche[n]='\0';
			}
			for (n=0; n<LONGMAX && argv[i][n]!='\0'&& argv[i][n]!=':' && argv[i][n]!='=';n++) {
				nomCherche[n]=argv[i][n];
			}
			//**si n>=(?)longmax et que argv[i][n]!=0 ==> erreur;a modifier pour UNIX

								//recherche dans le struct
			for (k=0, existe=0; k<nb && !existe; ){
				if(!strcmp(questions[k].shortname, nomCherche) && strlen(nomCherche)!=0){
					valide=1;
					existe=1;
					operFich=0;
				}
				else k++;
			}
			if(existe)
				if(argv[i][n] =='\0' && (questions[k].vartype!=BOOLVAL) ){
						return 0;
					}
				else
					// si la commande entree est trouvee dans le repertoire
					// et le reste de la commande peut etre valide (: ou = ou bool)

					switch (questions[k].vartype){
					case INTVAL:
						if ((sscanf(argv[i]+n+1, "%d", &tmpint))==1){
								*((int *)questions[k].outvar)=tmpint;
								break;
						}
						else {
							return 0;
						}
					case	REALVAL:
					    if ((sscanf(argv[i]+n+1,"%f",&tmpfl))==1){
							*((Real *)questions[k].outvar)=tmpfl;
							break;
					    }
						else {
							return 0;
						}
					case BOOLVAL:
						*((int *)questions[k].outvar)=1;
						break;
					case STRINGVAL:
						*((char **)questions[k].outvar)=argv[i]+n+1;
						break;
					case CHOICEVAL:
						*((char *)questions[k].outvar)=argv[i][n+1];
						break;
					}
		   //si la commande entree n'est pas dans le repertoire
		   //la traite comme un nom de fichier

			if (!valide){
									//pour le premier seulement
				if (noFich==0){
					operFich=1;
					for (j=0; j<nb && !trouve ; ){
						if (questions[j].vartype==LISTVAL)
							trouve=1;
						else j++;

					} //voir ancienne version ci-bas sinon
					if(!trouve){
							return 0;
					}
					else
						((ListFich *)(questions[j].outvar))->index = argv+i;
				}
									//pour tous
				if (operFich){
					noFich++;
					((ListFich *)(questions[j].outvar))->nbre = noFich;
				}
					else{
						return 0;
					}
			}
	}
	return (argc>1);
}

void chdir_robust(const char *dir) {
  if (chdir(dir)!=0) {
    cerr << "Cannot cd into " << dir << endl;
    ERRORQUIT("Aborting");
  }
}

int get_string(AutoString *ps, istream &file, char *delim) {
  AutoString accum;
  char c;
  while (1) {
     file.get(c);
     if (strchr(delim,c)!=NULL || file.eof()) break;
     accum+=c;
  }
  *ps=accum;
  if (file.eof()) return 0;
  file.putback(c);
  return 1;
}

int skip_delim(istream &file, char *delim) {
  char c;
  do {
     file.get(c);
  } while (strchr(delim,c)!=NULL && !file.eof());
  if (file.eof()) return 0;
  file.putback(c);
  return 1;
}
