#ifndef __INTERF_H__
#define __INTERF_H__

#include "machdep.h"
#include "misc.h"
#include "stringo.h"
#include <string.h>
#include <iostream.h>
#include <iomanip.h>
#include <stdio.h>

// ------------------------------ Entree de valeurs

enum VarType {TITLEVAL,INTVAL,REALVAL,BOOLVAL,STRINGVAL,CHOICEVAL,LISTVAL};

struct AskStruct {     // contains the caracteristics of a command-line option;
	char *shortname; // command line option name;
	char *longname;  // description string;
	VarType vartype; // type of the variable to initialize (see VarType);
	void *outvar;    // pointer to the variable to initialize;
};

struct ListFich {   // for the LISTVAL type;
	char **index; // array of strings to store;
	int nbre;     // size of the array;
};

// use argc and argv to initialize the variables pointed to in the array questions of lenght nb;
int get_values(int argc, char* argv[], int nb, AskStruct *questions);
// Displays the description strings;
void display_help(int nb, AskStruct *questions);

void chdir_robust(const char *dir);

int get_string(AutoString *ps, istream &file, char *delim=" \t\n");
int skip_delim(istream &file, char *delim=" \t\n");

#endif
