#ifndef _LINSOLVE_H_
#define _LINSOLVE_H_

#include "misc.h"
#include <math.h>
#include <complex.h>

Real *numrec_vector(long nl, long nh);
int *numrec_ivector(long nl, long nh);
void numrec_free_vector(Real *v, long nl, long nh);
void numrec_free_ivector(int *v, long nl, long nh);
Real **numrec_matrix(long nrl, long nrh, long ncl, long nch);
void numrec_free_matrix(Real **m, long nrl, long nrh, long ncl, long nch);

void linsolve(Real **a, int n, Real *rhs);
void ludcmp(Real **a, int n, int *indx, Real *d);
void lubksb(Real **a, int n, int *indx, Real *b);

/* eigenvalue problems */
void tred2(Real **a, int n, Real *d, Real *e, int do_vect);
void tqli(Real *d, Real*e, int n, Real **z, int do_vect);

#endif
