#include "chull.h"

int main(int argc, char *argv[]) {
  zero_tolerance=1e-5;
  iVector2d d(50,3);
  srand(3);
  Array<Array<Real> > p(d(0));
  Array<Real> e(d(0)); 
  ofstream ptfile("tmp.txt");
  for (int i=0; i<d(0); i++) {
    e(i)=uniform01();
    p(i).resize(d(1));
    Real s=0.;
    for (int j=0; j<d(1); j++) {
      p(i)(j)=uniform01();
      s+=p(i)(j);
      ptfile << p(i)(j) << " ";
    }
    product(&p(i),p(i),1./s);
    ptfile << endl;
  }

  Array<Real> fe;
  Array<Real> pure;
  calc_formation(&fe,&pure,p,e);
  cout << pure << endl;
  cout << fe << endl;
  return 0;

  LinkedList<PolytopeFace> hull;
  Array<Real> ground(d(1));
  ground(d(1)-1)=-1.;
  //ground.resize(0);
  calc_convex_hull(&hull, p, ground);
  LinkedListIterator<PolytopeFace> i(hull);
  for (; i; i++) {
    //cout << i->pts->get_size() << endl;
    for (int j=0; j<=i->pts.get_size(); j++) {
      for (int k=0; k<p((i->pts)(j % i->pts.get_size())).get_size(); k++) {
	cout << p((i->pts)(j % i->pts.get_size()))(k) << " ";
      }
      cout << endl;
    }
    cout << endl << endl;
  }
  cerr << "check" << endl;
  i.init(hull);
  for (; i; i++) {
    for (int k=0; k<d(0); k++) {
      //      cerr << inner_product(p(k),i->up)-(i->c) << endl;
      if (inner_product(p(k),i->up)-(i->c)>zero_tolerance) {
	cerr << "problem" << endl;
      }
    }
  }
}
